/* $Id */

/*
 $Log: parse.h,v $
 * Revision 1.8  1996/04/08  17:24:15  miller
 * Alteracao na ordem dos caracteres especiais
 *
 * Revision 1.7  1996/01/10  20:53:02  miller
 * Adicao da tabela de caracteres e da funcao pm_setchar(int,char) para
 * mudar um caractere de controle;
 *
 * Revision 1.6  1996/01/10  18:29:56  miller
 * Mudanca de '\' para '/'
 *
 * Revision 1.5  1996/01/10  17:44:30  miller
 * Adicao do OOM_CH (+);
 * Adicao do SPC2_CH (/), a ser usado;
 *
 * Revision 1.4  1995/12/21  16:15:47  miller
 * Conserto dos LOGs com tilt
 *
 * Revision 1.3  1995/12/20  14:32:54  almendra
 * parse => pm_parse
 * Prototipos de funcoes internas passam para static
 *
 * Revision 1.2  1995/12/14  19:56:21  almendra
 * Colocados Id: parse.h,v 1.3 1995/12/20 14:32:54 almendra Exp miller  e Log: parse.h,v
 *
 *
*/

#ifndef parse_h
#define parse_h

#define isclass(c) (isprint(c) && c != ']' && c != '-')

/* 
 * Tabela de caracteres (customizaveis atraves de pm_setchar)
 */

char *pm_chars = "|*+()[]-^/.?^${}~";
/*                01234567890123456     */
/* Adicionar 1 para uso em LUA          */

#define OR_CH	     pm_chars[0]	/* OR CHaracter			*/
#define CL_CH	     pm_chars[1]	/* CLosure CHaracter		*/
#define OOM_CH	     pm_chars[2]	/* One Or More CHaracter	*/
#define OPGR_CH	     pm_chars[3]	/* OPen  GRoup CHaracter	*/
#define CLGR_CH	     pm_chars[4]	/* CLose GRoup CHaracter	*/
#define OPCL_CH	     pm_chars[5]	/* OPen CLass CHaracter		*/
#define CLCL_CH	     pm_chars[6]	/* CLose CLass CHaracter	*/
#define SEPCL_CH     pm_chars[7]	/* SEParate CLass CHaracter	*/
#define NEGCL_CH     pm_chars[8]	/* NEGation CLass CHaracter	*/
#define SPC_CH       pm_chars[9]	/* SPeCial function CHaracter	*/
#define ANY_CH       pm_chars[10]	/* ANY CHaracter		*/
#define ONE_CH	     pm_chars[11]	/* ONE or no CHaracter		*/
#define BEGIN_CH     pm_chars[12]	/* BEGINning of a line CHaracter*/
#define END_CH       pm_chars[13]	/* END of a line CHaracter	*/
#define CAP_OPEN_CH  pm_chars[14]	/* CAPture OPEN CHaracter	*/
#define CAP_CLOSE_CH pm_chars[15]	/* CAPture CLOSE CHaracter	*/
#define NEG_CH	     pm_chars[16]	/* NEGation CHaracter		*/

#define SPC2_CH  '\\'		/* SPeCial 2 CHaracter */

#define isvalid(c) (c != 0 && c != OR_CH && c != OPGR_CH && c != CLGR_CH &&\
                         c != CL_CH && c != OPCL_CH && c != CLCL_CH &&\
                         c != CAP_OPEN_CH && c != CAP_CLOSE_CH && c != OOM_CH)

/* estrutura que contem as variaveis que sao usadas por todas as funcoes
       no parse.c */

typedef struct vars_st
{
  char *string;
  int state, j, num_states;
  fsm_st *fsm;
  short capture[30];
  short size;
  char nextcap;
  jmp_buf env;
}
vars_st;

#define isclass(c) (isprint(c) && c != ']' && c != '-')

#define MIN_NUM_STATES     100
#define STATE_BLOCK        30
#define MAX_FUNCTIONS      20

int pm_parse (char *text, fsm_st **fsm);
static int expression (vars_st * vars);
static int term (vars_st * vars);
static int factor (vars_st * vars);
static void error (vars_st *vars);
static void newstate (vars_st * vars);
static void setstate (vars_st * vars, int state, char ch, char command,
	       int next1, int next2);

#endif
