#ifndef PM_H
#define PM_H

void pmlib_open (void);

/*
 * Registra as seguintes funcoes:
 *
 * match (Texto, Padrao [, Inicio, Funcao_de_captura, Userdata_opcional]);
 *
 *   retorna o inicio e tamanho se encontra, nil caso contrario
 *   retorna tambem a tabela de capturas se continha alguma e nao recebeu funcao
 *
 * pm_setchar (numero, novo_char);
 *
 *   muda o comando NUMERO para usar o caractere NOVO_CHAR, onde o "default"
 *   e' o seguinte:
 *
 *  1	|	Or
 *  2	*	Closure
 *  3	+	One or more
 *  4	(	Open group
 *  5	)	Close group
 *  6	[	Open class
 *  7	]	Close class
 *  8	-	Separate class
 *  9	^	Negation (in class)
 *  10	/	Special function
 *  11	.	Any character
 *  12	?	One or none
 *  13	~	Negation (out of class)
 *  14	^	Anchor to beginning
 *  15	$	Anchor to end
 *  16	{	Open class
 *  17	}	Close class
 *
 * A variavel global pm_loop contem 0 se o pm_pmatch deve ser executado uma
 *  vez ou 1 se deve ser executado ate' o fim da entrada.
 */
#endif
