/* $Id: pmatch.h,v 1.10 1996/01/25 13:44:45 almendra Exp $ */

#ifndef pmatch_h
#define pmatch_h

typedef struct fsm_st
{
  char ch;
  int command;
  int next1;
  int next2;
}
fsm_st;

typedef int (*match_func) (char, long, long, char *, void *);

long pm_pmatch (long *, char *, char *, long,
		int (*)(char, long, long, char *, void *), void *);
int pm_parse (char *, fsm_st **);
int pm_setchar (int, char);
long pm_match (char *, fsm_st *, long, match_func, void *);
int pm_getCapture (int *, long *, long *);
int pm_storeCaptures (char, long, long, char *, void *);

 /* codigos de erro retornados pela funcao de interface pmatch */

#define PARSE_OK     0		/* Nenhum erro de parse */
#define MEM_ERROR   -2		/* Erro de memoria   */
#define PARSE_ERROR -3		/* Erro de parsing   */
#define NOMATCH -1

#endif
